﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinGrid.ExcelExport;

namespace _98233
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Id", typeof(int)).AutoIncrement = true;
            for (int i = 0; i < 5; i++)
            {
                dt.Columns.Add(string.Format("Column{0}", i), typeof(string)).DefaultValue = "Default Text";
            }

            for (int i = 0; i < 100; i++)
            {
                dt.Rows.Add();
            }

            ultraGrid1.DataSource = dt;

            ultraGridExcelExporter1.ExportStarted += new ExportStartedEventHandler(ultraGridExcelExporter1_ExportStarted);
           
        }

        void ultraGridExcelExporter1_ExportStarted(object sender, ExportStartedEventArgs e)
        {
            UltraGrid grid = (UltraGrid)e.Layout.Grid;

            foreach (UltraGridRow row in e.Rows)
            {
                row.Hidden = !IsRowOrAncestorSelected(grid.GetRowFromPrintRow(row));
            }
        }


        private bool IsRowOrAncestorSelected(UltraGridRow row) 
        { 
            UltraGridRow ancestor = row; 
            while (ancestor != null) 
            { if (ancestor.Selected)                    
                return true; 
                ancestor = ancestor.ParentRow; 
            } 
            return false; 
        }


       

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            ultraGridExcelExporter1.Export(ultraGrid1, "Test.xls");
            Process.Start("Test.xls");
        }
    }
}
